/*
  HPSDR CAT Control
  DH3CS, 2017-09-24
  programmer=arduino:avrispmkii


 * erzeugt folgende serielle Ausgabe bei Drehen des Inkrementalgebers
 * (da Impulsvervierfachung genutzt wird -> 4 Impuls pro Rastung)
 * ZZAG030;ZZAG034;ZZAG038;ZZAG042;ZZAG051;ZZAG062;ZZAG067;ZZAG074;ZZAG078;ZZAG084;ZZAG094;ZZAG100;ZZAG100;ZZAG100;
 * ZZAG100;ZZAG092;ZZAG088;ZZAG084;ZZAG080;ZZAG072;ZZAG067;ZZAG060;ZZAG056;ZZAG054;ZZAG040;ZZAG031;ZZAG024;ZZAG016;ZZAG012;ZZAG000;ZZAG000;ZZAG000;ZZAG000;ZZAG000;ZZAG000;ZZAG000;ZZAG000;ZZAG000;ZZAG000;ZZAG000;ZZAG000;ZZAG005;ZZAG014;ZZAG028;ZZAG032;ZZAG036;ZZAG040;
 */

#include <Encoder.h>
#include <TimerOne.h>

const byte InEnc1A = A1;
const byte InEnc1B = A2;

//const int InterruptPeriode = 50; //alle 50 millisecs

Encoder Enc1(InEnc1A, InEnc1B);
long Enc1Position = 0;     // = Enc1.read();
long Enc1PosMerker = 0;


// the setup routine runs once when you press reset:
void setup()
{
  // initialize the digital pin as an output.
  pinMode(InEnc1A, INPUT);
  pinMode(InEnc1B, INPUT);

  Enc1.write(30);

  Serial.begin(38400);
}

// the loop routine runs over and over again forever:
void loop() 
{
  Enc1Position = Enc1.read(); // Encoder 1 auslesen

  if ((millis() & 0xFE) == 0xFE)  // alle ca x msecs
  {

    // Encoder 1 z.B. für Lautstärke einstellen
    // long Enc1Position = Enc1.read();
    if (Enc1Position != Enc1PosMerker)
    {
      int Enc1Pos = Enc1Position;
      if (Enc1Position <0)   
      { 
        Enc1.write(0);
        Enc1Pos = 0;
      }
      if (Enc1Position >100) 
      {
        Enc1.write(100);
        Enc1Pos = 100;
      }
      Serial.print("ZZAG" + addNullen(String(Enc1Pos), 3) + ";");        
      Enc1PosMerker = Enc1Position;
    }
  }
}


String addNullen(const String & notfit, int i)
{
  String fin = "00000000000000000000"; // enthält 20 Nullen
  int len = i - notfit.length();
  if (len >= 0) return fin.substring(0, len) + notfit;
  else return notfit.substring(0, i);
}

